/**
 * Created by ChinaDivision on 2016/6/13.
 */

var chinadivision = {
    callCreateOrderAPI: function (e) {
        jQuery(".chinadivision-setting").remove();
        jQuery("#create_sku").remove();

        var checkbox = jQuery('input[name="post[]"]:checkbox:checked');
        if (checkbox.length < 1) {
            checkbox = jQuery('input[name="id[]"]:checkbox:checked');
            if (checkbox.length < 1) {
                checkbox = jQuery('input[name="order[]"]:checkbox:checked');
                if (checkbox.length < 1) {
                    alert("Please choose your order checkbox.");
                    return;
                }
            }
        }
        var order_ids = "";
        checkbox.each(function (i) {
            order_ids = order_ids + this.value + ",";
        });
        order_ids = order_ids.substr(0, order_ids.length - 1);
        jQuery.ajax({
            url: "../wp-content/plugins/chinadivision-woocommerce/chinadivision/chinadivision-bulk-create-order.php",
            type: 'post',
            data: {
                order_ids: order_ids
            },
            dataType: 'json',
            beforeSend: function () {
                jQuery(e).removeAttr("onclick");
                jQuery(e).attr("disabled", "disabled")
                jQuery(e).text("Create Order ...");
            },
            complete: function () {
                jQuery(e).attr("onclick", "javascript:chinadivision.callCreateOrderAPI(this);");
                jQuery(e).removeAttr("disabled");
                jQuery(e).text("Create Order");
            },
            success: function (data) {
                alert(data.msg);
            }
        });



        /* var url = "../wp-content/plugins/chinadivision-woocommerce/chinadivision/chinadivision-create-order-api.php";
         
         var data = {
         order_id: post_id,
         user_id: user_id,
         quantity: quantity,
         info: json_info
         };
         
         jQuery.post(url, data, function (res) {
         res = jQuery.parseJSON(res);
         if ('success' == res.msg) {
         tr_row.css("background-color", "#abc");
         checkbox.removeAttr("checked");
         }
         alert(res.msg);
         });*/
    },
    callSyncShipping: function (e) {
        jQuery(".chinadivision-setting").remove();
        jQuery("#create_sku").remove();

        var checkbox = jQuery('input[name="post[]"]:checkbox:checked');
        if (checkbox.length < 1) {
            alert("Please choose your order checkbox.");
            return;
        }
        var order_ids = "";
        jQuery('input[name="post[]"]:checkbox:checked').each(function (i) {
            order_ids = order_ids + this.value + ",";
        });
        order_ids = order_ids.substr(0, order_ids.length - 1);
        jQuery.ajax({
            url: "../wp-content/plugins/chinadivision-woocommerce/chinadivision/chinadivision-sync-shipping.php",
            type: 'post',
            data: {
                order_ids: order_ids
            },
            dataType: 'json',
            beforeSend: function () {
                jQuery(e).removeAttr("onclick");
                jQuery(e).attr("disabled", "disabled")
                jQuery(e).text("Sync Shipping ...");
            },
            complete: function () {
                jQuery(e).attr("onclick", "javascript:chinadivision.callSyncShipping(this);");
                jQuery(e).removeAttr("disabled");
                jQuery(e).text("Sync Shipping");
            },
            success: function (data) {
                alert(data.msg);
                window.location.reload();
            }
        });
    },
    getCreateSkuPage: function () {
        jQuery(".chinadivision-setting").remove();
        jQuery("#create_sku").remove();
        var page = '../wp-content/plugins/chinadivision-woocommerce/chinadivision/chinadivision-create-sku-page.php';
        var div = '<div id="create_sku" style="z-index: 9999;position: absolute;left: 225px;top: 115px;width: 75%;background-color:#ffffff;border:solid #e1e1e1 1px;"></div>';
        jQuery("body").prepend(div);
        jQuery("#create_sku").load(page);
    },
    getSettingPage: function () {
        jQuery(".chinadivision-setting").remove();
        jQuery("#create_sku").remove();
        var page = '../wp-content/plugins/chinadivision-woocommerce/chinadivision/chinadivision-setting-page.php';
        var div = '<div class="chinadivision-setting" style="z-index: 9999;position: absolute;left: 380px;height:420px;top: 115px;width: 40%;background-color:#ffffff;border:solid #e1e1e1 1px;"></div>';
        jQuery("body").prepend(div);
        jQuery(".chinadivision-setting").load(page);
    },
    saveSetting: function (e) {
        var apikeyObj = jQuery("#chinadivision-setting input[name=apikey]")
        var prefixObj = jQuery("#chinadivision-setting input[name=prefix]")
        var consumer_keyObj = jQuery("#chinadivision-setting input[name=consumer_key]")
        var consumer_secretObj = jQuery("#chinadivision-setting input[name=consumer_secret]")
        var debug_logObj = jQuery("#chinadivision-setting input[name=debug_log]")
        var apikey = jQuery.trim(apikeyObj.val());
        var prefix = jQuery.trim(prefixObj.val());
        var consumer_key = jQuery.trim(consumer_keyObj.val());
        var consumer_secret = jQuery.trim(consumer_secretObj.val());
        if (apikey.length == 0) {
            chinadivision.showError(apikeyObj);
            alert("apikey can not be empty");
            return false;
        }
        if (prefix.length == 0) {
            chinadivision.showError(prefixObj);
            alert("prefix can not be empty");
            return false;
        }
        if (consumer_key.length == 0) {
            chinadivision.showError(consumer_keyObj);
            alert("consumer key can not be empty");
            return false;
        }
        if (consumer_secret.length == 0) {
            chinadivision.showError(consumer_secretObj);
            alert("consumer secret can not be empty");
            return false;
        }
        jQuery.ajax({
            url: "../wp-content/plugins/chinadivision-woocommerce/chinadivision/chinadivision-setting.php",
            type: 'post',
            data: {
                apikey: apikey,
                prefix: prefix,
                consumer_key: consumer_key,
                consumer_secret: consumer_secret,
                debug_log: debug_logObj.is(':checked') ? 1 : 0,
            },
            dataType: 'json',
            beforeSend: function () {
                jQuery(e).removeAttr("onclick");
            },
            complete: function () {
                jQuery(e).attr("onclick", "javascript:chinadivision.saveSetting(this);");
            },
            success: function (data) {
                alert(data.msg);
                setTimeout(function () {
                    chinadivision.autoSaveWebhooks();
                    chinadivision.closeSettingPage();
                }, 800)
            }
        });
    },
    autoSaveWebhooks: function () {
        jQuery.ajax({
            url: "../wp-content/plugins/chinadivision-woocommerce/chinadivision/chinadivision-setting.php",
            type: 'post',
            data: {
                'act': 'auto_register_webhook',
            },
            dataType: 'json',
            success: function (data) {}
        });
    },
    closeSettingPage: function () {
        jQuery(".chinadivision-setting").remove();
    },
    addSKU: function () {
        var html = '<tr class="c_sku_tr c_sku_row">' +
                '<td class="c_sku_td"><input class="c_table_input c_must_input" type="text" placeholder="SKU serial number" value="" name="sku[]" onchange="chinadivision.getSkuInfo(this)" /></td>' +
                '<td class="c_sku_td"><input class="c_table_input c_must_input" type="text" placeholder="SKU quantity" value="" name="quantity[]" onkeyup="value=value.replace(/[^\\d]/g,' + "''" + ')" /></td>' +
                '<td class="c_sku_td"><input class="c_table_input c_must_input" type="text" placeholder="SKU price" value="" name="price[]" /></td>' +
                '<td class="c_sku_td"><input class="c_table_input c_must_input" type="text" placeholder="SKU color" value="" name="color[]" /></td>' +
                '<td class="c_sku_td"><input class="c_table_input c_must_input" type="text" placeholder="SKU size" value="" name="size[]" /></td>' +
                '<td class="c_sku_td"><input class="c_table_input c_must_input" type="text" placeholder="Product name" value="" name="product_name[]" /></td>' +
                '<td class="c_sku_td"><input class="c_table_input c_must_input" type="text" placeholder="Product links" value="" name="product_url[]" /></td>' +
                '<td class="c_sku_td"><input class="button button-primary" type="button" onclick="chinadivision.deleteSKU(this)" value="Delete" /></td>' +
                '</tr>';
        jQuery("#skus_info").append(html);
    },
    deleteSKU: function (e) {
        jQuery(e).parent().parent().remove();
    },
    cancelSKU: function () {
        jQuery("#create_sku").remove();
    },
    getSkuInfo: function (e) {
        var sku = jQuery(e).val();
        var td = jQuery(e).parent().siblings("td");
        if ('' == sku || undefined == sku) {
            td.children("input[name='price[]']").val(null);
            td.children("input[name='product_name[]']").val(null);
            td.children("input[name='product_url[]']").val(null);
            return;
        }
        var url = '../wp-content/plugins/chinadivision-woocommerce/chinadivision/chinadivision-get-sku-info.php';
        jQuery.get(url, {sku: sku}, function (res) {
            res = jQuery.parseJSON(res);
            if (res.mark) {
                td.children("input[name='price[]']").val(res.price);
                td.children("input[name='product_name[]']").val(res.product_name);
                td.children("input[name='product_url[]']").val(res.product_url);
            } else {
                td.children("input[name='price[]']").val(null);
                td.children("input[name='product_name[]']").val(null);
                td.children("input[name='product_url[]']").val(null);
            }
        });
    },
    submitSKU: function () {
        jQuery(".prompt_box").removeAttr("style");
        jQuery(".prompt_box").removeClass("prompt_box");
        jQuery(".empty_error").addClass("hidden_info");

        var package_number = jQuery("#package_number").val();
        var tracking_number = jQuery("#tracking_number").val();
        var shipping_method = jQuery("#shipping_method").val();
        var total_quantity = jQuery("#quantity").val();
        //var inspection      = jQuery("#inspection").val();
        var remark = jQuery("#remark").val();
        //var business_type   = jQuery("#business_type").val();

        var empty_tag = 0;
        if ('' == package_number) {
            chinadivision.showError(jQuery("#package_number"));
            empty_tag++;
        }
        if ('' == tracking_number) {
            chinadivision.showError(jQuery("#tracking_number"));
            empty_tag++;
        }
        if ('' == shipping_method) {
            chinadivision.showError(jQuery("#shipping_method"));
            empty_tag++;
        }
        if ('' == total_quantity) {
            chinadivision.showError(jQuery("#quantity"));
            empty_tag++;
        }

        var info = "[";
        var json, sku, quantity, price, color, size, product_name, product_url;
        var sum_quantity = 0;
        jQuery('input[name="sku[]"]').each(function (i) {
            sku = jQuery('input[name="sku[]"]').eq(i).val();
            quantity = jQuery('input[name="quantity[]"]').eq(i).val();
            price = jQuery('input[name="price[]"]').eq(i).val();
            color = jQuery('input[name="color[]"]').eq(i).val();
            size = jQuery('input[name="size[]"]').eq(i).val();
            product_name = jQuery('input[name="product_name[]"]').eq(i).val();
            product_url = jQuery('input[name="product_url[]"]').eq(i).val();

            if ('' == sku) {
                empty_tag++;
                chinadivision.showError(jQuery('input[name="sku[]"]').eq(i));
            }
            if ('' == quantity) {
                empty_tag++;
                chinadivision.showError(jQuery('input[name="quantity[]"]').eq(i));
            }
            if ('' == size) {
                empty_tag++;
                chinadivision.showError(jQuery('input[name="size[]"]').eq(i));
            }
            if ('' == price) {
                empty_tag++;
                chinadivision.showError(jQuery('input[name="price[]"]').eq(i));
            }
            if ('' == color) {
                empty_tag++;
                chinadivision.showError(jQuery('input[name="color[]"]').eq(i));
            }
            if ('' == product_name) {
                empty_tag++;
                chinadivision.showError(jQuery('input[name="product_name[]"]').eq(i));
            }
            if ('' == product_url) {
                empty_tag++;
                chinadivision.showError(jQuery('input[name="product_url[]"]').eq(i));
            }

            sum_quantity += parseInt(quantity);

            json = {"sku": sku, "quantity": quantity, "price": price, "color": color, "size": size, "product_name": product_name, "product_url": product_url};
            if (i) {
                info += ",";
            }
            info += JSON.stringify(json);
        });
        info += "]";

        if (empty_tag) {
            alert(empty_tag + " required information is empty, please fill out these information before submission !");
            return;
        }
        if (total_quantity != sum_quantity) {
            jQuery("input[name^='quantity']").addClass("prompt_box").css("border", "2px solid rgba(255, 0, 0, 0.15)");
            alert("The sum of the total number and the number of each SKU, please check it before you submit !");
            return;
        }

        if (confirm("Are you sure you want to submit this page ?")) {
            var href = window.location.href;
            var url = '../wp-content/plugins/chinadivision-woocommerce/chinadivision/chinadivision-create-sku-api.php';
            var data = {
                package_number: package_number,
                tracking_number: tracking_number,
                shipping_method: shipping_method,
                quantity: total_quantity,
                remark: remark,
                info: info
            };
            jQuery.post(url, data, function (res) {
                res = jQuery.parseJSON(res);
                alert(res.msg);
                jQuery('#create_sku').remove();
            });
        }
    },
    showError: function (e) {
        jQuery(e).css("border", "2px solid #ff3939");
    },
    hideError: function (e) {
        jQuery(e).css("border", "1px solid #8c8f94");
    }
};