<?php

require_once './chinadivision-config.php';
require_once './chinadivision-common-function.php';
require_once './chinadivision-host.php';

if (cd_check_apikey_is_empty()) {
    cd_api_response_failed('apikey can not be empty.');
}
if (empty($_POST['info'])) {
    cd_api_response_failed('SKU info can not be empty.');
}

$info = json_decode($_POST['info'], true);

$header = array(
    'Content-Type:application/x-www-form-urlencoded',
    'apikey:' . CHINADIVISION_API_KEY,
);

$post_data = array(
    'package_number' => $_POST['package_number'],
    'tracking_number' => $_POST['tracking_number'],
    'shipping_method' => $_POST['shipping_method'],
    'quantity' => (int) $_POST['quantity'],
    'inspection' => 1,
    'remark' => $_POST['remark'],
    'business_type' => 1,
    'info' => $info,
);

$res = cd_http(CD_CREATE_SKU_URL, 'POST', $post_data, $header);

echo $res;
